package AccessLog::Tags;

use strict;
use warnings;

sub _hdlr_accesslog {
    my ( $ctx, $args, $cond ) = @_;
    my $component = MT->component( 'AccessLog' );
    my $tmpl = File::Spec->catfile( $component->path, 'tmpl', 'handlers', 'custom_handler_1.tmpl' );
    my $tag_name = 'accesslog';
    require MT::FileMgr;
    my $fmgr = MT::FileMgr->new( 'Local' );
    my $template = $fmgr->get_data( $tmpl );
    if ( ( ref $args ) eq 'HASH' ) {
        for my $key ( keys %$args ) {
            if ( $key ne '@' ) {
                $ctx->{ __stash }{ vars }{ $tag_name . '.' . $key } = $args->{ $key };
            }
        }
    }
    my $build = MT::Builder->new;
    my $tokens = $build->compile( $ctx, $template )
        or return $ctx->error( $component->translate(
            'Parse error: [_1]', $build->errstr ) );
    defined( my $out = $build->build( $ctx, $tokens ) )
        or return $ctx->error( $component->translate(
            'Build error: [_1]', $build->errstr ) );
    $out;
}

1;